library emoji_pick;

import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class Emojies extends StatefulWidget {

  final List<String> tabsname;
  final List<dynamic> tabsemoji;
  var maxheight;
  final TextEditingController inputtext;
  final Color tabcolor;
  final Color bgcolor;



  Emojies({this.tabsname,this.tabsemoji,this.maxheight,this.inputtext,this.tabcolor = Colors.blue,this.bgcolor = Colors.white});



  @override
  _EmojiesState createState() => _EmojiesState();
}

class _EmojiesState extends State<Emojies> {

  var _alignment = Alignment.bottomCenter;
  int _selectedtab = 0;
  StreamController<double> _controller = StreamController<double>();




  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    Stream stream = _controller.stream;
    stream.listen((value) {
      if(value != 0.0){
        SystemChannels.textInput.invokeMethod('TextInput.hide');
      }
    });




  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
    _controller.close();
  }





  Future<bool> onWillPop() {
    if(widget.maxheight == 0.0){
      return Future.value(true);
    }
    else{
      setState(() {
        widget.maxheight = 0.0;
      });
      return Future.value(false);
    }

  }


  @override
  Widget build(BuildContext context) {



    return WillPopScope(child: AnimatedContainer(
      padding: EdgeInsets.all(5.0),
      duration: const Duration(milliseconds: 65),
      alignment: _alignment,
      height: widget.maxheight,
      child: Container(
        decoration: BoxDecoration(
            borderRadius:
            BorderRadius.all(const Radius.circular(4.0)),
            color: widget.bgcolor,
            boxShadow: [
              new BoxShadow(color: Colors.black12,blurRadius: 5,spreadRadius: 1)
            ]
        ),
        alignment: Alignment.center,
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Row(
              children: <Widget>[
                InkWell(
                  onTap: (){

                    setState(() {
                      widget.maxheight = 0.0;
                    });
                    SystemChannels.textInput.invokeMethod('TextInput.show');
                  },
                  child: Container(
                    margin: EdgeInsets.only(left: 5,right: 2,top: 7,bottom: 1),
                    padding: EdgeInsets.only(left: 10,right: 5,bottom: 0,top: 0),
                    alignment: Alignment.center,
                    decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(30)), // make rounded corner
                    child: Icon(Icons.keyboard,color: widget.tabcolor,),
                  ),
                ),
                Expanded(child: SingleChildScrollView(
                  scrollDirection: Axis.horizontal,
                  child: Row(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: List.generate(widget.tabsname.length, (index){
                      return InkWell(
                        onTap: (){
                          setState(() {
                            _selectedtab = index;
                          });
                        },
                        child: Container(
                          margin: EdgeInsets.only(left: 5,right: 5,top: 7,bottom: 1),
                          padding: EdgeInsets.only(left: 10,right: 10,bottom: 6,top: 6),
                          alignment: Alignment.center,
                          decoration: BoxDecoration(
                              color: _selectedtab == index ? widget.tabcolor : Colors.grey,
                              borderRadius: BorderRadius.circular(30)), // make rounded corner
                          child: Text(widget.tabsname[index],style: TextStyle(color: Colors.white),),
                        ),
                      );
                    }),
                  ),
                ))
              ],
            ),
            SizedBox(height: 5,),
            Divider(height: 2,color: Colors.grey),

            Flexible(child: _buildemojilist() )
          ],
        ),
      ),
    ), onWillPop: onWillPop);

  }



  Widget _buildemojilist(){

    _controller.add(widget.maxheight);


    try{
      return GridView.count(
        crossAxisCount: 7,
        children: List.generate(widget.tabsemoji[_selectedtab].length, (index) {
          return InkWell(
            onTap: (){
              //widget.inputtext.text = widget.tabsemoji[_selectedtab][index];

              int getCurpot = widget.inputtext.selection.base.offset;
              String _newValue = widget.inputtext.text.toString();

              try{
                String newVal = _newValue.substring(0,getCurpot) + widget.tabsemoji[_selectedtab][index] + _newValue.substring(getCurpot);
                widget.inputtext.value = TextEditingValue(
                  text: newVal,
                  selection: TextSelection.fromPosition(
                    TextPosition(offset: _newValue.substring(0,getCurpot).length + widget.tabsemoji[_selectedtab][index].length),
                  ),
                );
              }
              catch(e){
                String newVal = widget.tabsemoji[_selectedtab][index];
                widget.inputtext.value = TextEditingValue(
                  text: newVal,
                  selection: TextSelection.fromPosition(
                    TextPosition(offset: widget.tabsemoji[_selectedtab][index].length),
                  ),
                );
              }

            },
            child: Container(
              padding: const EdgeInsets.only(top: 5,right: 10,left: 10,bottom: 2),
              child: Text(widget.tabsemoji[_selectedtab][index],style: TextStyle(fontSize: 27),),
            ),
          );
        }),
      );
    }
    catch(e){
      return Center(child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          Text("😒",style: TextStyle(fontSize: 64),),
          SizedBox(height: 20,),
          Text("No emoji found",style: TextStyle(fontSize: 27),)
        ],
      ),);
    }

  }

}
